---
- set_fact:
    arch: "arm64"
  when: ansible_architecture == "aarch64"

- set_fact:
    arch: "amd64"
  when: ansible_architecture == "x86_64"

- set_fact:
    url: "https://mirror.rmt/binaries/{{ arch }}/step_linux_{{ cli_version }}_{{ arch }}.tar.gz"
    dest: "/tmp/step.tar.gz"
    src: "/tmp/step_{{ cli_version }}/bin/step"
    autocomplete: "/tmp/step_{{ cli_version }}/autocomplete/bash_autocomplete"

- name: Download ACME Binaries
  get_url:
    url: "{{ url }}"
    dest: "{{ dest }}"

- name: Unarchive Packages
  unarchive:
    src: "{{ dest }}"
    dest: "/tmp"
    remote_src: yes

- name: Remove old step cli version
  file:
    path: "/usr/bin/step"
    state: absent
  when: stat_result.stat.exists

- name: Install Step Package
  copy:
    src: "{{ src }}"
    dest: "/usr/bin/step"
    remote_src: yes

- name: Move Bash Autocomplete
  copy:
    src: "{{ autocomplete }}"
    dest: "/usr/share/bash-completion/completions/step"
    remote_src: yes

- name: Validate binary is executable
  file:
    path: "/usr/bin/step"
    state: touch
    mode: 0755

- name: Ansible remove file glob
  file:
    path: "{{ item }}"
    state: absent
  with_items:
    - "/tmp/step.tar.gz"
    - "/tmp/step_{{ cli_version }}/"

- name: Generate Certificate
  shell: |
    /usr/bin/step ca bootstrap \
      --ca-url {{ ca_url }} \
      --fingerprint {{ ca_fingerprint }}
  register: output
- debug: "msg={{ output }}"

- name: Install CA Cert
  shell: /usr/bin/step certificate install $(step path)/certs/root_ca.crt
